/* 
   Program to translate lex format to gap format.
*/

/* version 0.1 */

#include <stdio.h>
#include <string.h>

int
main(argc,argv)
     int argc;
     char *argv[];

{
  char inputline[2000];
  char outputchunk[50];
  int v,i;
  int isurface;
  int ichar;
  int outputlen;
  int f0,f1,f2,f3,g2;
  int degree[100],j,f0new,tmp,n[20],maxdeg;

  isurface = 0;
  
  while (fgets(inputline,2000,stdin) != NULL)
    {
      isurface++;
      
      f3 = strlen(inputline)/4;
      f0 = 0;
      for (i=4*f3-1; i>=0; i--) {
	v = inputline[i]-'a';
	if (v+1 > f0) {
	  f0new = v+1;
	  for (j=f0; j<f0new; j++)
	    degree[j] = 0;
	  f0 = f0new;
	}
	degree[v]++;
      }
      for (v=4; v<f0; v++)
	n[v] = 0;
      maxdeg = 0;
      for (v=0; v<f0; v++) {
	degree[v] = degree[v]/2 + 2;
	if (degree[v] > maxdeg)
	  maxdeg = degree[v];
	n[degree[v]]++;
      }
      for (i=0; i<f0-1; i++)
	for (j=f0-1; j>i; j--)
	  if (degree[j-1] > degree[j]) {
	    tmp = degree[j-1];
	    degree[j-1] = degree[j];
	    degree[j] = tmp;
	  }
      f1 = f3 + f0;
      f2 = 2*f1 - 2*f0;
      g2 = f1 -4*f0 +10;

      ichar = 0;
      fprintf(stdout,"## %d, f = (%d,%d,%d,%d), g_2 = %d.\n##  deg = %d",
	      isurface,f0,f1,f2,f3,g2,degree[0]);
      for (v=1; v<f0; v++)
	fprintf(stdout,",%d",degree[v]);
      fprintf(stdout,"\n");
      fprintf(stdout,"##  n_4,... = %d",n[4]);
      for (v=5; v<=maxdeg; v++)
	fprintf(stdout,",%d",n[v]);
      fprintf(stdout,"\n");

      sprintf(outputchunk,"facets:=[[%d,%d,%d,%d],",
	      inputline[ichar]-'a'+1,inputline[ichar+1]-'a'+1,
	      inputline[ichar+2]-'a'+1,inputline[ichar+3]-'a'+1);
      fprintf(stdout,"%s",outputchunk);
      outputlen = strlen(outputchunk);
      ichar += 4;
      while (inputline[ichar] != 0 && inputline[ichar] != '\n') {
	if (inputline[ichar+4] != 0 && inputline[ichar+4] != '\n')
	  sprintf(outputchunk,"[%d,%d,%d,%d],",
		  inputline[ichar]-'a'+1,inputline[ichar+1]-'a'+1,
		  inputline[ichar+2]-'a'+1,inputline[ichar+3]-'a'+1);
	else
	  sprintf(outputchunk,"[%d,%d,%d,%d]]",
		  inputline[ichar]-'a'+1,inputline[ichar+1]-'a'+1,
		  inputline[ichar+2]-'a'+1,inputline[ichar+3]-'a'+1);
	ichar += 4;
	if (outputlen + strlen(outputchunk) > 72) {
	  fprintf(stdout,"\n  ");
	  outputlen = 1;
	}
	fprintf(stdout,"%s",outputchunk);
	outputlen += strlen(outputchunk);
      }
      
      
      fprintf(stdout,"\n");
      //fprintf(stdout,"Read(\"ID_MINIMAL\");\n");
    }
  return 1;
}
